Document new --date=<format>
[gitweb.git] / git-stash.sh
index f01494dc1bf52b79698e3a2a73be8d179a1cd61b..de13dd1812170ca76eb5706aefb7f59d22be6d48 100755 (executable)
@@ -3,6 +3,7 @@
 
 USAGE='[ | list | show | apply | clear]'
 
+SUBDIRECTORY_OK=Yes
 . git-sh-setup
 require_work_tree
 
@@ -57,11 +58,11 @@ save_stash () {
 
        # state of the working tree
        w_tree=$( (
+               rm -f "$TMP-index" &&
+               cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
                GIT_INDEX_FILE="$TMP-index" &&
                export GIT_INDEX_FILE &&
-
-               rm -f "$TMP-index" &&
-               git read-tree $i_tree &&
+               git read-tree -m $i_tree &&
                git add -u &&
                git write-tree &&
                rm -f "$TMP-index"
@@ -111,6 +112,13 @@ apply_stash () {
        git diff-files --quiet ||
                die 'Cannot restore on top of a dirty state'
 
+       unstash_index=
+       case "$1" in
+       --index)
+               unstash_index=t
+               shift
+       esac
+
        # current index state
        c_tree=$(git write-tree) ||
                die 'Cannot apply a stash in the middle of a merge'
@@ -120,6 +128,15 @@ apply_stash () {
        b_tree=$(git rev-parse --verify "$s^:") ||
                die "$*: no valid stashed state found"
 
+       test -z "$unstash_index" || {
+               git diff --binary $s^2^..$s^2 | git apply --cached
+               test $? -ne 0 &&
+                       die 'Conflicts in index. Try without --index.'
+               unstashed_index_tree=$(git-write-tree) ||
+                       die 'Could not save index tree'
+               git reset
+       }
+
        eval "
                GITHEAD_$w_tree='Stashed changes' &&
                GITHEAD_$c_tree='Updated upstream' &&
@@ -137,9 +154,12 @@ apply_stash () {
                        die "Cannot unstage modified files"
                git-status
                rm -f "$a"
+               test -z "$unstash_index" || git read-tree $unstashed_index_tree
        else
                # Merge conflict; keep the exit status from merge-recursive
-               exit
+               status=$?
+               test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
+               exit $status
        fi
 }